<?php
/*
Plugin Name: SMF Commenter
Plugin URI: http://solid-orange.com/software/smf-commenter
Description: When a new Wordpress post is published the post is duplicated in the forums and a link is added to the word press post. 
Author: twistedsymphony
Version: .41
Author URI: http://solid-orange.com/
*/ 
/*  Copyright 2007  twistedsymphony  (email : twistedsymphony@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2.1 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
I offer no warranties and no support for this plugin. Maybe it's mean but I
have better things to do. I wrote this plugin because there was no good solution
to integrating WP and SMF. I only offer this plugin because I know there are
many others interested in this integration which is the only reason I'm
releasing it at all. I made it for my own devices but if someone else can use
this as is without my help then great. I've tried to comment as much of this
as possible because if you ask me for help I probably wont have time to respond.
*/

/*******************************************************
INSTALLATION INSTRUCTIONS 
1. Copy all files to your wordpress plugin folder
2. Edit the line below: include_once('/forums/Sources/Subs-Post.php');
to reflect the absolute server path of the Subs-Post.php file
3. Activate the plugin from the Wordpress plugin screen and then set the options
in the SMF Commentor options page.
*******************************************************/
if (!defined('SMF'))
	define('SMF', 1);
include_once('/forums/Sources/Subs-Post.php');

//returns the SMF topic id from the postmeta table if an SMF ID has been set for the specified post
function get_smf_id($wp_id){
    global $wpdb;
        //check the post meta table for smf_id tags and return the value if one exists
    @$smf_id = $wpdb->get_var("SELECT meta_value FROM $wpdb->postmeta WHERE post_id=$wp_id and meta_key='smf_id'");
    //return the SMF topic id
    return $smf_id;
    }

//if SMF topic ID exists and is valid then add a link to the end of the WP post. else do nothing
function add_smf_link($content = '') {
    Global $id; //get the WP id of the current post.
    $wpsmfc = get_option('wpsmfc'); //get the user options
    $smf_id = get_smf_id($id); //get the smf id
    //check if the SMF ID was returned or invalid
    If ((is_numeric($smf_id)) && ($smf_id != 0)){
        //add the link text to the end of the content
        $content .= "<p><a href=".$wpsmfc['wpsmfc_url']."/index.php?topic=".$smf_id.">".$wpsmfc['wpsmfc_wptxt']."</a></p>";
        }
    //return the content
    return $content;
    }
    
//checks if there is an SMF topic id associated with a published post, if not it creates a new topic and associates the ids
function create_smf_topic($id){
    global $wpdb; //needed to use the WP database
    $wpsmfc = get_option('wpsmfc'); //get the user options
    $smf_id = get_smf_id($id); //get the SMF ID from the database
    //checks if the id exists
    If (is_null($smf_id)){
        //generates the url (which includes necessary data) to the topic creation script
        $url = get_option('home').'/wp-content/plugins/wp_smf_commenter/smf_create_topic.php?wp_id='.$id.'&smf_board='.$wpsmfc['wpsmfc_bid'].'&smf_user='.$wpsmfc['wpsmfc_mid'].'&ltxt='.$wpsmfc['wpsmfc_smtxt'];
        //fires off the url... there are 4 ways to do this and none of them seem to work right.
        //wp_redirect($url);
        //header("Location: $url");
        echo '<head><meta HTTP-EQUIV="REFRESH" content="0; url='.$url.'"></head>';
        //header("Refresh: 0;url=$url");
        //echo '<script type="text/javascript">window.open(\''.$url.'\')</script>';
        //fopen ($url, "rb");
        }
    }
    
//this function filters the comment number on the news page to reflect the number of comments in SMF
function smf_comment_count(){
    global $id, $wpdb;
    $smf_id = get_smf_id($id); //get the smf id
    if (is_null($smf_id)){//check that an SMF ID was returned
        $smf_count = 0;
        }else{
            @$smf_count = $wpdb->get_var("SELECT COUNT(*) FROM smf_messages WHERE ID_TOPIC = $smf_id"); //get the post count from the SMF tables
            $smf_count -=1; //subtract 1 to account for the first post created by WP.
        }
    return $smf_count;
    }

//Calls the wp_smf_pollster_options.php page and adds it to the admin options when requested by the action below
function wpsmfc_add_options_page(){
    add_options_page('SMF Commenter Options', 'SMF Commenter', 'manage_options', 'wp_smf_commenter/wp_smf_commenter_options.php');
    }

//creats an SMF topic and relates the WP post id to the SMF topic id in a meta tag (if they do not already exist) whenever a post is published
add_action('publish_post', 'create_smf_topic');

// fires off the "add_smf_link" function whenever post content is dispalyed in Wordpress
add_filter('the_content', 'add_smf_link');

// sets the # of comments to the actual number of comments in the forum
add_filter('get_comments_number', 'smf_comment_count');

//calls the function to create the options page whenever it is requested.
add_action('admin_head', 'wpsmfc_add_options_page');
?>
